#!/usr/bin/python2
# -*- coding: utf-8 -*-

import matplotlib   #on JET must  be used Qt4Agg backend
matplotlib.rcParams['backend'] = 'Agg'
matplotlib.rc('font', family='arial', size='10')
matplotlib.rc('text', usetex=True)

import sys
sys.path.append('/home/michal/Desktop/Prace/Golem/web_framework')

import pygolem


from numpy import *
from pygolem.config import *
from pygolem.modules import *
from matplotlib.pyplot import *
import time
from shutil import copy
import os

def setup():
    print \
    """DIAGN NIstandart SETUP:
	ch0...Uloop
	ch1...Bt
	ch2...Ip
	ch3...Photodiode-O.Vrba:fotodioda BPW34 v odporovem zapojení
	"""


def arming():
    os.system('echo ahoj|telnet NIstandardDAS 5020 > /dev/null 2>/dev/null &')
    


def acquisition():
    copy('mnt/NIstandard/NIdata.lvm', './')
    os.symlink('NIdata.lvm',  'Nidatap.lvm')
    data = loadtxt('Nidatap.lvm')
    #sed 's/,/\./g' Nidata.lvm > Nidatap.lvm;\
    save('Nidatap', single(data))  # save binary data

def graphs(file_type):

    name = "NI Standard"
    
    # graph all
    out = get_data('Nidatap', 'ch', '')
    paralel_multiplot(out, name , 'graph1', (6,7), 100,  'vertical', file_type)

    # icon
    out = get_data('Nidatap', '', '', xlabel = "")
    paralel_multiplot(out, "" , 'icon', (4,3), 40)

    #integrated
    out = get_data('Nidatap', 'ch', "",integrated=True )
    paralel_multiplot(out, name + ' Integrated' , 'graph2', (6,7), 100,  'vertical', file_type)

def main():
    setup()
    graphs('png')
    graphs('svg')


if __name__ == "__main__":
    main()