#!/usr/bin/python2
import matplotlib 
matplotlib.rcParams['backend'] = 'Agg'
matplotlib.rc('font', family='arial', size='10')
matplotlib.rc('text', usetex=True)

import sys
sys.path.append('/home/michal/Desktop/Prace/Golem/web_framework')

from numpy import *
from pygolem.config import *
from pygolem.modules import *

from basic_diagn import *




    
def plot_data(file_type):
    shot = 1000
    plasma = 1
    
    
    t0 = time.time()

    
    #GPfPlasma  => home page 

    data = [
	get_data('Uloop_dp', 'Loop voltage', 'U [V]', ylim = [0,None]),
	get_data('Btoroidal_dp', 'Toroidal mag. field', 'B$_t$ [T]' , ylim = [0,None]),
	get_data('Iplasma_dp', 'Plasma current', 'I$_{p}$ [kA]' , ylim = [0,None], data_rescale = 1e-3) if plasma else \
	get_data('Irogowski_dp', 'Plasma current', 'I$_{p}$+I$_{ch}$ [kA]', data_rescale = 1e-3, ylim = [0,None]) ,
	[get_data('Photod_dp', 'Visible', 'Photod [a.u.]' , ylim = [0,None]),
	get_data('PhotodHalpha_dp', 'H$_\\alpha', 'Photod [a.u.]' , ylim = [0,None])] ,
	]

    paralel_multiplot(data, 'Golem shot No:' + str(shot), 'graphpres', (9,7), 100, 'vertical', file_type)

	
    # GPf
    data = [
	get_data('Uloop_dp', 'Loop voltage', 'U [V]'),
	get_data('Btoroidal_dp', 'Toroidal mag. field', 'B$_t$ [T]'),
	get_data('Irogowski_dp', 'Total current', 'I$_{ch}$ [kA]' , data_rescale = 1e-3),
	[get_data('Photod_dp', 'Visible', 'Photod [a.u.]' ),
	get_data('PhotodHalpha_dp', 'H$_\\alpha', 'Photod [a.u.]' )] ,
	]
    
    paralel_multiplot(data, 'Golem shot No:' + str(shot), 'graphprint', (9,7), 100, 'vertical', file_type)



    data = [
	get_data('Uloop_dp', 'Loop voltage', 'U [V]',  xlim = [0,25]),
	get_data('Btoroidal_dp', 'Toroidal mag. field', 'B$_t$ [T]' , xlim = [0,25]),
	get_data('Iplasma_dp', 'Plasma current', 'I$_{p}$ [kA]' , xlim = [0,25], data_rescale = 1e-3) if plasma else \
	get_data('Irogowski_dp', 'Plasma current', 'I$_{p}$+I$_{ch}$ [kA]', data_rescale = 1e-3) ,
	[get_data('Photod_dp', 'Visible', 'Photod [a.u.]', xlim = [0,25]),
	get_data('PhotodHalpha_dp', 'H$_\\alpha', 'Photod [a.u.]' , xlim = [0,25])] ,
	]

    paralel_multiplot(data, 'Golem shot No:' + str(shot) + ' final data ', 'graphpresfull', (9,7), 100, 'vertical', file_type)

   
    ##GPitegrated
    data = [
	[get_data('Uloop_dp', 'Loop voltage', 'U [V]',  xlim = [0,25])],
	get_data('Btoroidal_dp', 'Toroidal mag. field', 'B$_t$ [T]',  xlim = [0,25]),
	[get_data('Irogowski_dp', 'Total current', 'I$_p$+I$_{ch}$ [kA]' ,  xlim = [0,25], data_rescale = 1e-3)] + \
	[get_data('Iplasma_dp', 'Plasma current', 'I$_{p}$ [kA]' , xlim = [0,25], data_rescale = 1e-3)] if plasma else [],
	[get_data('Photod_dp', 'Visible', 'Photod [a.u.]',   xlim = [0,25]),
	get_data('PhotodHalpha_dp', 'H$_\\alpha', 'Photod [a.u.]' ,  xlim = [0,25])] ,
	]

    paralel_multiplot(data, 'Golem shot No:' + str(shot) + " - integrated data", 'graphpresi', (9,7), 100, 'vertical', file_type)

    ###raw

    data = [
	get_data('Uloop_dp', 'Loop voltage', 'U [V]', xlim = [0,25] ),
	get_data('dBdt_toroidal_dp', 'Derivative  of mag. field', 'dB$_t$/dt [DAS V]', xlim = [0,25] ),
	get_data('dIdt_rogowski_dp', 'Derivative of current', 'dI$_{p+ch}$/dt [DAS V]',  xlim = [0,25] ),
	[get_data('Photod_dp', 'Visible', 'Photod [a.u.]' , xlim = [0,25] ),
	get_data('PhotodHalpha_dp', 'H$_\\alpha', '[DAS V]',  xlim = [0,25] )] ,
	]

    paralel_multiplot(data, 'Golem shot No:' + str(shot) + " - raw data", 'graphpresb', (9,7), 100, 'vertical', file_type)


    # icon
    data = [
	get_data('Uloop_dp', '', '', xlabel = ""),
	[get_data('Irogowski_dp', '', '', xlabel = "" )] +\
	[get_data('Iplasma_dp','', '', xlabel = "" )] if plasma else []
	]
	
    paralel_multiplot(data, '', 'icon', (4,3), 40)


    # GPic
    data = [
	get_data('Uloop_dp', '', 'U [V]', ylim = [0,None],  xlim = [0,25], xlabel=""),
	[get_data('Irogowski_dp', '', 'I$_p$+I$_{ch}$ [kA]' , ylim = [0,None],  xlim = [0,25], xlabel = "", data_rescale = 1e-3)] + \
	[get_data('Iplasma_dp', '', 'I$_{p}$ [kA]' , ylim = [0,None], xlim = [0,25], xlabel = "",  data_rescale = 1e-3)] if plasma else []
	]
    
    paralel_multiplot(data, "", 'graphic', (9,1.5), 100,  'horizontal', file_type)

    print ' Time: %g' %  ( time.time() - t0)
    

def prepare_data():
    t = time.time()
    
    Aktual_PfeifferMerkaVakua = loadconst("Aktual_PfeifferMerkaVakua")

    [Btor, BtMax, BtMean] = getBtoroidal()
    [Uloop, UloopMax, UloopMean] = getUloop()
    [Irog, dIdt_rogMax, IrogMax] = getIrogowski()
    [Ipla, Ich] = getIplasma(Uloop,Irog)
    Plasma, PlasmaStart, PlasmaEnd, PlasmaTimeLength = PlasmaDetect(Ipla)
    Photod = getPhotod(PlasmaStart)
    PhotodHalpha = getPhotodHalpha(PlasmaStart)
    
    MeanBt = getMeanBt(Btor,PlasmaStart, PlasmaEnd )
    TotalCharge  = getTotalCharge(Ipla, PlasmaStart,PlasmaEnd )

    MeanUloop = getMeanUloop(Uloop, PlasmaStart,PlasmaEnd )
    MeanIpla = getMeanCurrent(Ipla, PlasmaStart,PlasmaEnd )
    OhmicHeatingPower = getOhmicHeatingPower(MeanUloop,MeanIpla)
    Qedge = getQedge(MeanBt,MeanIpla)

    ElectronTemperature = getElectronTemperature(MeanUloop, MeanIpla)
    Umax, Btime, Bbreak, Bipla = getBreakDownVoltage(Uloop, Btor, Ipla, PlasmaStart, PlasmaEnd)

    StateEqElectronDensity = getStateEqElectronDensity(Aktual_PfeifferMerkaVakua)

    ChamberResistance = getChamberResistance(Plasma)

    Plasma  = Failures(Plasma, UloopMax, dIdt_rogMax, MeanUloop, BtMax, MeanBt, PlasmaStart, PlasmaEnd  )

    GreenwaldDensity = getGreenwaldDensity(Ipla)
    OhmicHeatingPower = getOhmicHeatingPowerTime(Ipla, Uloop)
    Qedge = getQedgeTime(Btor,Ipla)
    MagneticFlux = getMagneticFlux(Uloop)
    
    print "time" , time.time() - t

    
def main():
  
    prepare_data()

    plot_data('png')
    plot_data('svg')
    

  
  


if __name__ == "__main__":
    main()
    
	