function i_plasma, u_loop, curr, dt

;---------------------
;Help
;---------------------

;Purpose of function is to calculate total plasma
;current, without chamber current cross talk (since our 
;Rog coil envelops chamber as well).

;---------------------
;Initialisation
;---------------------

u_loop = double(u_loop)
curr = double(curr)
dt = double(dt)

rog_cal=53D5
ch_res = 9.24D-3	;[\Omega] Resistance of chamber
ch_ind = 0.6D-6		;[H] Inductance of chamber

;---------------------
;initialisation of data
;---------------------

N_data = n_elements(curr)
curr = rog_cal*dt*total(curr,/cumulative)

;---------------------
;I_plasma calculation - according to Odstrcil
;---------------------

i_ch = 0D

for i=0d, N_data-1d do begin
	i_ch = (u_loop[i] + ch_ind*i_ch/dt)/(ch_res + ch_ind/dt)
	curr[i] = curr[i] - i_ch
endfor

;---------------------
;finalisation
;---------------------

return, curr

end