#!/usr/bin/python2
# -*- coding: utf-8 -*-

import matplotlib   #on JET must  be used Qt4Agg backend
matplotlib.rcParams['backend'] = 'Agg'
matplotlib.rc('font', family='arial', size='10')
matplotlib.rc('text', usetex=True)

import sys
sys.path.append('/home/michal/Desktop/Prace/Golem/web_framework')

import pygolem


from numpy import *
from pygolem.config import *
from pygolem.modules import *
from matplotlib.pyplot import *
import time
from shutil import copy, move
import os

def setup():
    print \
    """DIAGN Flukes SETUP:
	
	"""


def arming():
    pass

def acquisition():
    pass

    
def graphs(file_type):

    title = "Flukes"

    flukes = [
    { #number 1
        "measuring" : "Toroidal magnetic field coils current",
        "maximum" : 6e3 #[A]
        },
    { #number 2
        "measuring" : "Current drive primary winding current",
        "maximum" : 6e3 #[A]
        },
    { #number 3
        "measuring" : "Breakdown winding current",
        "maximum" : 6e3 #[A]
        },
    { #number 4
        "measuring" : "Stabilization vert. mag. field coils current",
        "maximum" : 6e3 #[A]
        },
    ]

    save('config', flukes)
    



    scaling_factor = ones(len(flukes))
    name = []
    for i in range(len(flukes)):
	measuring, maximum = flukes[i].values()
	scaling_factor[i] = 5 * 10 ** -(log10(maximum / 6) + 1)
	name += [measuring]
    out = get_data('Nidatap', name , "I [A]", xlim = [0,None],data_rescale = 1/scaling_factor, integrated=False, columns = [0,1,2,3])

    paralel_multiplot(out, title , 'flukes', (9,7), 100, 'vertical', file_type)

    #icon
    out = get_data('Nidatap', "", "" , xlim = [0,None], xlabel = "",integrated=False )
    paralel_multiplot(out, "" , 'icon', (4,3), 40)



    
def main():
    setup()
    graphs('png')
    graphs('svg')



if __name__ == "__main__":
    main()

    