#!/bin/perl

sub narovnani (@)
{
  my $aver2=0;
  
  for ($i=32000;$i<32000+$TriggerLine;$i++)
  {
    $aver2+=$_[$i];
  }
  $aver2=$aver2/$TriggerLine;

  for ($i=5000;$i<32000;$i++)
  {
    $_[$i]-=($i-5000)*$aver2/(32000-5000);
  }

  for ($i=32000;$i<$LineCount;$i++)
  {
    $_[$i]-=$aver2;
  }
}

sub integrace_mc (@)
{
  my $aver=0;
  my $integr=0;

  for ($i=0;$i<$TriggerLine;$i++)
  {
    $aver+=$_[$i];
  }
  $aver=$aver/$TriggerLine;

  for ($i=0;$i<$LineCount;$i++)
  {
    $integr+=($_[$i]-$aver);
    $_[$i]=$integr*$DeltaTs/$Mirnov_S_Eff;
  }
}



$LineCount=40000;
$TriggerLine=3500;
$DeltaTs=1e-6;#[s]

$Stab_S_Eff=2.376352;#[m^2]
$Mirnov_S_Eff=0.003705;#[m^2]
$MirnovPosition=93;#[mm]
$MirnovPosition_m=0.093;#[m]


open DATA, "PapouchSt_01" or die "cant open Papouch 1";
@data=<DATA>;
close (DATA);

for ($i=0;$i<$LineCount;$i++) 
{
  @row=split('	',$data[$i]);
  $mc1_[$i]=$row[1];
}
@mc1=@mc1_;
integrace_mc (@mc1);
narovnani (@mc1);

open DATA, "PapouchSt_02" or die "cant open Papouch 2";
@data=<DATA>;
close (DATA);

for ($i=0;$i<$LineCount;$i++) 
{
  @row=split('	',$data[$i]);
  $mc5_[$i]=$row[1];
}
@mc5=@mc5_;
integrace_mc (@mc5);
narovnani (@mc5);

open DATA, "PapouchSt_03" or die "cant open Papouch 3";
@data=<DATA>;
close (DATA);

for ($i=0;$i<$LineCount;$i++) 
{
  @row=split('	',$data[$i]);
  $mc9_[$i]=$row[1];
}
@mc9=@mc9_;
integrace_mc (@mc9);
narovnani (@mc9);

open DATA, "PapouchSt_04" or die "cant open Papouch 4";
@data=<DATA>;
close (DATA);

for ($i=0;$i<$LineCount;$i++) 
{
  @row=split('	',$data[$i]);
  $mc13_[$i]=$row[1];
}
@mc13=@mc13_;
integrace_mc (@mc13);
narovnani (@mc13);

open DATA, "Ub_limit" or die "cant open Ub_limit";
$Ub_limit=<DATA>;
close (DATA);
$Ub_limit*=1;


open CIL, ">mc_integr";
$time=0;
for ($i=0;$i<$LineCount;$i++)
{
  print CIL $time."\t".$mc1[$i]."\t".$mc5[$i]."\t".$mc9[$i]."\t".$mc13[$i]."\n";
  $time+=$DeltaTs;
}
close(CIL);


open DATA, $Ub_limit."no_plasma" or die "cant open $Ub_limit etalon";
@data=<DATA>;
close (DATA);
open CIL, ">no_plasma";
for ($i=0;$i<$LineCount;$i++)
{
  @row=split('	',$data[$i]);
  $mc1[$i]-=$row[1];
  $mc5[$i]-=$row[2];
  $mc9[$i]-=$row[3];
  $mc13[$i]-=$row[4];
  print CIL $data[$i];
}
close(CIL);


open CIL, ">mc_signal";
$time=0;
for ($i=0;$i<$LineCount;$i++)
{
  print CIL $time."\t".$mc1[$i]."\t".$mc5[$i]."\t".$mc9[$i]."\t".$mc13[$i]."\n";
  $time+=$DeltaTs;
}
close(CIL);

open CIL, ">displacement";
$time=0;
for ($i=0;$i<$LineCount;$i++)
{
   if (($mc5[$i]+$mc13[$i])==0) {$disZ[$i]=0}
   else {$disZ[$i]=($mc5[$i]-$mc13[$i])*$MirnovPosition/($mc5[$i]+$mc13[$i])}

  if (($mc1[$i]+$mc9[$i])==0) {$disR[$i]=0}
  else {$disR[$i]=($mc1[$i]-$mc9[$i])*$MirnovPosition/($mc1[$i]+$mc9[$i])}

  print CIL $time."\t".$disR[$i]."\t".$disZ[$i]."\n";
  $time+=$DeltaTs;
}
close(CIL);

